#!/usr/bin/python
# -*- coding: utf-8 -*-

import argparse
import os, sys
import copy
import time

import technoap.sitcp as sitcp
import technoap.device.apu101 as apu101



#device IP address
DEST_IPADDR = "192.168.10.128"

##########################################################
def main(argv):

	try:
		if argv.control == 'on' or argv.control == 'off':
			rbcp = sitcp.rbcp.RBCP(True)
			rbcp.setdefaultdest(DEST_IPADDR)
			config = apu101.configHV.ConfigHV(rbcp)

			if argv.control == 'on':
				result = config.outputVolatageON()		#ON
			else:
				result = config.outputVolatageOFF()		#OFF

			if result == True:
				print ("control [%s] success!!!" % (argv.control))
			else:
				print ("control [%s] failure..." % (argv.control))
		else:
			print ("parameter error, nothing [--control on/off]...")

	except Exception as ex:
		print (ex)


##########################################################
if __name__ == "__main__":
	parser = argparse.ArgumentParser(description='High voltage outpout control.')
	parser.add_argument("--control", type=str, required=True, help="control(on / off)")
	args = parser.parse_args()
	main(args)

