#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import math
import array
import socket

from . import register
from ...sitcp import fasttxbase


class FastDataTX(fasttxbase.FastTXBase):

	############################################
	def __init__(self, rbcp = None):
		self.__initializing()
		super(FastDataTX, self).__init__(rbcp)

	############################################
	def __initializing(self):
		self.mRegisterAttribute = register.Register()
		super(FastDataTX, self)._FastTXBase__initializing()

	############################################
	def readHistogram(self, chn, bins = 0, rbcp = None, dest_port = None):

		rxdata = None

		rbcp0 = self.getUsingRBCP(rbcp)

		reg_attb = self.mRegisterAttribute.getAttribute("RQH")
		address = reg_attb.mAddress
		value = chn - 1
		rxbytes = 32768
		rxdata0 = super(FastDataTX, self).readHistogram(address, value, rxbytes, rbcp0, dest_port)

        ####################
		rxdata = rxdata0

		if (bins is not None) and (rxdata0 is not None):
			rvbins = len(rxdata0)

			if bins > 0 and rvbins > 0:
				_last = min(rvbins, bins)
				rxdata = rxdata0[0:_last]

				_1st = _last
				_last = bins

				for i in range(_1st, _last):
					rxdata.append(0)
        ####################

		return rxdata




