#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys

from ..common import reginfo

class Register(object):
	#################################
	mInited = False

	mListRegister = {
		#common
		"MOD": reginfo.RegInfo("", 0xb4000010, 2),
		"MMD": reginfo.RegInfo("", 0xb4000012, 2),
		"AQS": reginfo.RegInfo("", 0xb4000014, 2),
		"MTM": reginfo.RegInfo("", 0xb4000016, 6),
		"RLT": reginfo.RegInfo("", 0xb400001c, 6),	#read only
		"CLR": reginfo.RegInfo("", 0xb4000040, 2),
		"RQH": reginfo.RegInfo("", 0xb400004a, 2),
		"CLS": reginfo.RegInfo("", 0xb400004e, 2),
		"SCS": reginfo.RegInfo("", 0xb4000050, 2),
		#"PHI": reginfo.RegInfo("", 0xb4000062, 2),
		"FRN": reginfo.RegInfo("", 0xb4000066, 2),
		"TGE": reginfo.RegInfo("", 0xb4000068, 2),
		"TSO": reginfo.RegInfo("", 0xb400006a, 2),
		"TPO": reginfo.RegInfo("", 0xb400006c, 2),
		"TLV": reginfo.RegInfo("", 0xb400006e, 2),
		"DAC": reginfo.RegInfo("", 0xb400007a, 2),
		#"CCH": reginfo.RegInfo("", 0xb4000090, 2),
		#"CDL": reginfo.RegInfo("", 0xb4000092, 2),
		#"CTM": reginfo.RegInfo("", 0xb400009a, 2),
		#"CGT": reginfo.RegInfo("", 0xb400009c, 2),
		"RRG": reginfo.RegInfo("", 0xb400009e, 2),
		"RCH": reginfo.RegInfo("", 0xb40000c6, 2),
		#"AXS": reginfo.RegInfo("", 0xb40000d6, 2),
		#channel
		"ACG": reginfo.RegInfo("", 0xb4000200, 2),
		"ADG": reginfo.RegInfo("", 0xb4000202, 2),
		"FFD": reginfo.RegInfo("", 0xb4000204, 2),
		"FFI": reginfo.RegInfo("", 0xb4000206, 2),
		"SFR": reginfo.RegInfo("", 0xb4000208, 2),
		"SFP": reginfo.RegInfo("", 0xb400020a, 2),
		"FPZ": reginfo.RegInfo("", 0xb400020c, 2),
		"SPZ": reginfo.RegInfo("", 0xb400020e, 2),
		"FTH": reginfo.RegInfo("", 0xb4000210, 2),
		"LLD": reginfo.RegInfo("", 0xb4000212, 2),
		"ULD": reginfo.RegInfo("", 0xb4000214, 2),
		"STH": reginfo.RegInfo("", 0xb4000216, 2),
		"PUR": reginfo.RegInfo("", 0xb4000218, 2),
		"POL": reginfo.RegInfo("", 0xb400021a, 2),
		"ICT": reginfo.RegInfo("", 0xb400021c, 4),	#read-only
		"TCT": reginfo.RegInfo("", 0xb4000220, 4),	#read-only
		"ICR": reginfo.RegInfo("", 0xb400022c, 4),	#read-only
		"TCR": reginfo.RegInfo("", 0xb4000230, 4),	#read-only
		"PCR": reginfo.RegInfo("", 0xb4000234, 2),	#read-only
		"WVS": reginfo.RegInfo("", 0xb4000236, 2),
		"DCG": reginfo.RegInfo("", 0xb400023a, 2),
		"DFG": reginfo.RegInfo("", 0xb400023c, 2),
		"TMS": reginfo.RegInfo("", 0xb400023e, 2),
		"CFF": reginfo.RegInfo("", 0xb4000240, 2),
		"CFD": reginfo.RegInfo("", 0xb4000242, 2),
		"IHW": reginfo.RegInfo("", 0xb4000244, 2),
		"CLT": reginfo.RegInfo("", 0xb4000246, 6),
		"CDT": reginfo.RegInfo("", 0xb400024c, 6),
		"DIF": reginfo.RegInfo("", 0xb4000254, 2),
		"PZD": reginfo.RegInfo("", 0xb4000256, 2),
		"FGD": reginfo.RegInfo("", 0xb4000258, 2),
		"BTS": reginfo.RegInfo("", 0xb400025a, 2),
		"BRS": reginfo.RegInfo("", 0xb400025c, 2),
		#"IHT": reginfo.RegInfo("", 0xb400025e, 2),
		#HV
		"HST": reginfo.RegInfo("", 0xb4002200, 2),	#read-only
		"HVM": reginfo.RegInfo("", 0xb4002202, 2),	#read-only
		"HIM": reginfo.RegInfo("", 0xb4002204, 2),	#read-only
		"HSM": reginfo.RegInfo("", 0xb4002206, 2),	#read-only
		"HSP": reginfo.RegInfo("", 0xb4002208, 2),
		"HSJ": reginfo.RegInfo("", 0xb400220a, 2),
		"HEN": reginfo.RegInfo("", 0xb400220e, 2),	#status
		"HSW": reginfo.RegInfo("", 0xb4002210, 4),	#status
		"HVD": reginfo.RegInfo("", 0xb4002214, 2),
		"PDO": reginfo.RegInfo("", 0xb4002216, 2),
		"PDF": reginfo.RegInfo("", 0xb4002218, 2),
		"NDO": reginfo.RegInfo("", 0xb400221a, 2),
		"NDF": reginfo.RegInfo("", 0xb400221c, 2),
		"PVO": reginfo.RegInfo("", 0xb400221e, 2),
		"PVF": reginfo.RegInfo("", 0xb4002220, 2),
		"NVO": reginfo.RegInfo("", 0xb4002222, 2),
		"NVF": reginfo.RegInfo("", 0xb4002224, 2),
		"PIO": reginfo.RegInfo("", 0xb4002226, 2),
		"PIF": reginfo.RegInfo("", 0xb4002228, 2),
		"NIO": reginfo.RegInfo("", 0xb400222a, 2),
		"NIF": reginfo.RegInfo("", 0xb400222c, 2),
		"HPL": reginfo.RegInfo("", 0xb4002360, 2),
		"HPC": reginfo.RegInfo("", 0xb40023fe, 2),
		"___": None
	}
	
	##########################################################
	def __init__(self):
		Register.initRegister()

	##########################################################
	@staticmethod
	def initRegister():
		
		if Register.mInited == False:
			for key in Register.mListRegister.keys():
				var = Register.mListRegister[key]
				if not var is None:
					var.mName = key

			Register.mInited  = True

		return (0)

	##########################################################
	@staticmethod
	def getAttribute(name):
		Register.initRegister()
		return Register.mListRegister[name]

