#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys

import numpy as np
import matplotlib.pyplot as plt


class Spectrum(object):
	
	#########################################################
	def __init__(self, xwidth = None):
		self.__intializing()

		if xwidth is not None:
			self.creating(xwidth)

	#########################################################
	def __intializing(self):
		self.mFigure = None
		self.mAX = None
		self.mX = None
		self.mY = None
		self.mLines = None

	#########################################################
	def creating(self, xwidth):
		self.mX = np.array([i for i in range(xwidth)], dtype='u4')
		self.mY = np.array([0 for i in range(xwidth)], dtype='u4')

	#########################################################
	def plotting(self, run1st = False):
		if run1st == True:
			self.mFigure, self.mAX = plt.subplots(1, 1)
			self.mLines, = self.mAX.plot(self.mX, self.mY)
		else:
			self.mAX.plot(self.mX, self.mY)

	#########################################################
	def update(self):
		self.mLines.set_data(self.mX, self.mY)

	#########################################################
	def updateValue(self, xpos, value, runReflection = False):
		self.mY[xpos] = value
		self.mLines.set_data(self.mX, self.mY)
		
		if runReflection == True:
			self.update()

	#########################################################
	def updateValueAll(self, value, runReflection = False):
		counts = min(len(value), len(self.mY))
		for x in range(counts):
			self.mY[x] = value[x]

		if runReflection == True:
			self.update()

	#########################################################
	def setScaleX(self, minval = None, maxval = None):
		xmin = minval if minval is not None else self.mX.min()
		xmax = maxval if maxval is not None else self.mX.max()
		self.mAX.set_xlim(xmin, xmax)
	
	#########################################################
	def setScaleY(self, minval = None, maxval = None):
		ymin = minval if minval is not None else self.mY.min()
		ymax = maxval if maxval is not None else self.mY.max()
		self.mAX.set_ylim(ymin, ymax)

	#########################################################
	@staticmethod
	def pause(sec):
		plt.pause(sec)





