#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import socket

from . import rbcpraw, rbcpbase
from ..num import byteorder, bitconverter


class RBCP(rbcpbase.RBCPBase):
	
	#########################################################
	def __init__(self, initRun = False, src_port = rbcpraw.AUTOASSIGN_PORT, src_ipaddr = rbcpraw.DEFAULT_SRC_IPADDR):
		super(RBCP, self).__init__(initRun, src_port, src_ipaddr)

	#########################################################
	def readNbytes(self, address, nbytes, destipaddr = None, destport = None):

		nbits = nbytes * 8

		if nbits == 8:
			value = self.read8bit(address,  destipaddr, destport)
		elif nbits == 16:
			value = self.read16bit(address, destipaddr, destport)
		elif nbits == 32:
			value = self.read32bit(address, destipaddr, destport)
		elif nbits == 48:
			value = self.read48bit(address, destipaddr, destport)
		elif nbits == 64:
			value = self.read64bit(address, destipaddr, destport)
		else:
			value = None

		return value

	#########################################################
	def readNbytesSigned(self, address, nbytes, destipaddr = None, destport = None):

		nbits = nbytes * 8

		if nbits == 8:
			value = self.read8bitSigned( address, destipaddr, destport)
		elif nbits == 16:
			value = self.read16bitSigned(address, destipaddr, destport)
		elif nbits == 32:
			value = self.read32bitSigned(address, destipaddr, destport)
		elif nbits == 48:
			value = self.read48bitSigned(address, destipaddr, destport)
		elif nbits == 64:
			value = self.read64bitSigned(address, destipaddr, destport)
		else:
			value = None

		return value

	#########################################################
	def writeNbytes(self, address, value, nbytes, destipaddr = None, destport = None):

		nbits = abs(nbytes * 8)

		if nbits == 8:
			result = self.write8bit( address, value, destipaddr, destport)
		elif nbits == 16:
			result = self.write16bit(address, value, destipaddr, destport)
		elif nbits == 32:
			result = self.write32bit(address, value, destipaddr, destport)
		elif nbits == 48:
			result = self.write48bit(address, value, destipaddr, destport)
		elif nbits == 64:
			result = self.write64bit(address, value, destipaddr, destport)
		else:
			result = False

		return result

